/* Bxbasm : AConsole.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012        */


/* ----- includes ----- */
#include "prototyp.h"


/***********************
   variable types:
    int    = no symbol,
    long   = %,
    float  = !,
    double = #,
    string = $
/* ---------------
   array types:
    long   = %,
    float  = !,
    double = #,
    string = $
***********************/




void func_GetConslWndHandl()
{
    writeln("; --------------------------------------------------");
    writeln("GetConsoleWndHandle proc");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL   hConWnd:HWND");
    writeln("  LOCAL   os:OSVERSIONINFO");
    writeln("  LOCAL   szTempTitle[64]:BYTE");
    writeln("  LOCAL   szClassName[128]:BYTE");
    writeln("  LOCAL   szOriginalTitle[1024]:BYTE");
    writeln("  LOCAL   TkCnt:DWORD");
    writeln("  LOCAL   CurProcID:DWORD");
    writeln(";");
    writeln("  mov os.dwOSVersionInfoSize, sizeof OSVERSIONINFO");
    writeln("  invoke GetVersionEx, addr os");
    writeln("  invoke GetConsoleTitle, addr szOriginalTitle, sizeof szOriginalTitle");
    writeln("  call GetCurrentProcessId");
    writeln("  mov  CurProcID, eax");
    writeln("  call GetTickCount");
    writeln("  mov TkCnt, eax");

//;    invoke sprintf, szTempTitle, szPrmStr, TkCnt, CurProcID

    writeln("  push  CurProcID");
    writeln("  push  TkCnt");
    writeln("  lea  eax, szPrmStr");
    writeln("  push eax");
    writeln("  lea  eax, szTempTitle");
    writeln("  push eax");
    writeln("  call  sprintf");
    writeln("  invoke SetConsoleTitle, addr szTempTitle");
    writeln("  invoke Sleep, 40");
    writeln("  invoke FindWindow, NULL, addr szTempTitle");
    writeln("  mov  hConWnd, eax");
    writeln("  invoke SetConsoleTitle, addr szOriginalTitle");
    writeln("  mov  eax, hConWnd");
    writeln("  ret");
    writeln("GetConsoleWndHandle endp");
    writeln("; =========================================================================");
}
/* ------ end GetConslWndHandl ------ */




void Do_print()
{   char ch, varname[VAR_NAME];
    int pi, type, mark, len;

/* printf("Doprint::%s", p_string); /**/

    len = strlen(p_string);
    pi = e_pos;
    pi = iswhiter(pi);
    ch = p_string[pi];

    if(ch == '#')                 /* print to file output */
    {
        e_pos = pi;
        print_file(len);
        return;
    }

    e_pos = pi;

    if(strchr(":\n", ch))         /* --- print newline --- */
    {
        writeln("  printstr lf");
        return;
    }

    while((pi < len) && (strchr("\n\0", ch) == 0))
    {
   /* printf("ch=%c pi=%d len=%d\n", ch, pi, len); /**/

        if(isdigit(ch))           /* process a string function */
        {
            prn_function(len);
            pi = e_pos;
            ch = p_string[pi];
            pi++;
        }
        else
        {
            strcpy(varname, "VARX");
            s_pos = pi;
            mark = find_strng(varname);
            mark--;

            if((mark >= 0) && (mark == pi))
            {
                mark = 1;
            }
            else
            {
                mark = 0;
            }

            strcpy(varname, get_varname());
            type = get_ObjectType(varname);      /* object type specifier */
            pi = e_pos;

      /* ch = p_string[pi]; */
      /* printf("name=%s type=%d ch=>%c< pi=%d\n", varname, type, ch, pi); */

            if(type == 0)              /* write string variable */
            {
                write_str(indent);

                if(mark == 0)          /* a regular string variable */
                {
                    write_str("  mov  eax, [");
                    write_str(varname);
                    writeln("]");
                    writeln("  .if eax != 0");
                    write_str(indent);
                    writeln("    printvar eax");
                    writeln("  .endif");
                }
                else                   /* a temp string variable */
                {
                    write_str("  printstr ");
                    writeln(varname);
                }
            }
            else if(type == 6)         /* write string variable */
            {
                prn_strarry(varname, len);
                pi = e_pos;
                pi++;
            }
            else
            {
                pi = s_pos;            /* push pointer back */
                e_pos = pi;
                prn_expression();      /* variable or math expression */
                pi = e_pos;
                ch = p_string[pi];

                while(strchr("$)", ch) != 0)     /* is it end of statement */
                {
                    pi++;
                    ch = p_string[pi];
                }
            }
        }

        pi = iswhiter(pi);
        ch = p_string[pi];

   /* printf("ch=%c pi=%d\n", ch, pi); /**/

        if(ch == ',')
        {
            writeln("  printstr tab");
        }
        else if(strchr(":\n", ch) != 0)
        {
            write_str(indent);
            writeln("  printstr lf");
        }

        if(strchr("\n\0", ch) == 0)    /* is it end of statement */
        {
            pi++;
            pi = iswhiter(pi);
            ch = p_string[pi];
            e_pos = pi;
        }
   /* printf("ch=%c pi=%d\n", ch, pi); /**/

    }
}
/*---------- end Do_print ----------*/



void prn_expression()
{

    writeln("; --------------------------------------------------");
    writeln("  FINIT \t\t\t; initialize x87");

    a_Expression();               /* call: recursive descent parser */

    write_str("  FSTP  x87buff");
    writeln("\t\t\t; store in print buffer");
    writeln("  invoke FloatToStr2, x87buff, addr FltString");
    writeln("  printstr FltString");
}
/*---------- end prn_expression ----------*/



void prn_strarry(char *name, int len)  /* print an array string */
{   char varname[VAR_NAME];
    int pi, xcnt;


    strcpy(varname, name);        /* enter: array$(n,...) */

    pi = e_pos;
    pi = get_paren(pi, len);
    xcnt = get_ObjectParm(varname);

    writeln("; --------------------------------------------------");

    get_offset(varname, len, xcnt);

    writeln("  mov  eax, [edi]");      /* load string address to EAX */
    writeln("  .if eax != 0");
    writeln("    printvar eax");
    writeln("  .endif");

}
/*---------- end prn_strarry ----------*/



void prn_function(int len)
{   int type;


    type = (int) get_avalue();
    string_functions(len, type);

    if(type == 6)
    {
        writeln("  printstr IntString");
    }
    else
    {
        writeln("  printstr BffrInput");
    }
}
/*---------- end prn_function ----------*/



void Do_beep()
{
    writeln("  invoke Beep, 800, 250");
    /*	dwFreq,	// sound frequency, in hertz
        dwDuration 	// sound duration, in milliseconds
    */
}
/*---------- end Do_beep ----------*/



void Do_cls()           /* call clear-screen */
{
    writeln("  cls");
}
/*---------- end Do_cls ----------*/



void Do_locate()
{   char rows[VAR_NAME], cols[VAR_NAME];
    int pi, len, ab_code=3, x=line_ndx;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;

    if(pi < len)                       /* --- get row --- */
    {
        strcpy(rows, get_varname());   /* varname */
        pi = e_pos;
    }
    else                          /* failed to find alpha/num */
    {
        a_bort(ab_code, x);
    }

    pi = get_alpha(pi, len);      /* comma separates row and column */
    e_pos = pi;

    if(pi < len)                  /* --- get column --- */
    {
        strcpy(cols, get_varname());   /* digit-or-varname */
    }
    else
    {
        a_bort(ab_code, x);
    }

    write_str("  invoke locate, ");    /* --- now position cursor --- */
    write_str(cols);
    write_str(", ");
    write_str(rows);
    writeln("\t\t; locate cursor");

}
/*---------- end Do_locate ----------*/













