/* bxbasm : ADInput.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012       */
/*         ** stripped down version for Linux             */



/* ----- function prototypes ----- */
#include "prototyp.h"



void Scan_Obj(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, len, xcnt, type;
    int ab_code=20, x=line_ndx;


    strcpy(varname, Name);
    pi = e_pos;
    ch = p_string[pi];
    len = strlen(p_string);
    xcnt = get_paramsCount(pi, len);   /* get params count */
    pi++;
    pi = get_paren(pi, len);
    pi++;
    pi = iswhiter(pi);
    ch = p_string[pi];

    switch(ch)
    {   case '$':
            type = 6;             /* string array */
            break;
        case '%':
            type = 7;             /* integer array */
            break;
        case '!':
            type = 8;             /* float array */
            break;
        case '#':
            type = 9;             /* double array */
            break;
        case '@':
        case '&':
            type = 10;            /* long integer */
            break;
        default:
            type = 7;             /* integer array */
            break;
    }

    if(check_VarName(varname) != 0)
    {
        a_bort(ab_code,x);
    }

    if(check_arrayName(varname) == 0)
    {
        x_write_str("\t");
        x_write_str(varname);
        x_writeln("\t\tDD\t?");
        x_writeln("\t\t\tDW\t61\tdup(?)");
    }

    Sav_ObjName(varname, type, xcnt);       /* save object name */
    p_string[pi] = ' ';

                                       /* --- save p_string to array --- */
    strcpy(array1[line_ndx], p_string);     /* store to array */

    pi = iswhiter(pi);
    e_pos = pi;

}
/*---------- end Scan_Obj ----------*/



void Scan_Var(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, pend, pstart;


    strcpy(varname, Name);
    pstart = s_pos;
    pi = e_pos;
    pend = pi;
    pi = iswhiter(pi);
    ch = p_string[pi];

    if(ch == '$')                 /* string variable -or- array */
    {
        p_string[pi] = ' ';
        pi = iswhiter(pi);
        ch = p_string[pi];

        if(ch == '*')             /* a string array */
        {
            e_pos = pend;
            Fix_StrArray2(varname);
            p_string[pi] = ' ';
            pi = iswhiter(pi);
            pi = relocate(pi, pend);
        }
        else
        {
            p_string[pend] = ' ';
            e_pos = pend;
            s_pos = pstart;
            Sav_String(varname);
            StorVar(varname);
        }
    }
    else if(ch == '%')            /* integer variable -or- array */
    {
        p_string[pi] = ' ';
        pi = iswhiter(pi);
        ch = p_string[pi];

        if(ch == '*')             /* a integer array */
        {
            e_pos = pend;
            Fix_VarArray2(varname, 7);
            p_string[pi] = ' ';
            pi = iswhiter(pi);
            pi = relocate(pi, pend);
        }
        else
        {
            p_string[pend] = ' ';
            e_pos = pend;
            s_pos = pstart;
            Sav_Destin(2, varname);
        }
    }
    else if(ch == '!')            /* single variable -or- array */
    {
        p_string[pi] = ' ';
        pi = iswhiter(pi);
        ch = p_string[pi];

        if(ch == '*')             /* an array */
        {
            e_pos = pend;
            Fix_VarArray2(varname, 8);
            p_string[pi] = ' ';
            pi = iswhiter(pi);
            pi = relocate(pi, pend);
        }
        else
        {
            p_string[pend] = ' ';
            e_pos = pend;
            s_pos = pstart;
            Sav_Destin(3, varname);
        }
    }
    else if(ch == '#')            /* double variable -or- array */
    {
        p_string[pi] = ' ';
        pi = iswhiter(pi);
        ch = p_string[pi];

        if(ch == '*')             /* an array */
        {
            e_pos = pend;
            Fix_VarArray2(varname, 9);
            p_string[pi] = ' ';
            pi = iswhiter(pi);
            pi = relocate(pi, pend);
        }
        else
        {
            p_string[pend] = ' ';
            e_pos = pend;
            s_pos = pstart;
            Sav_Destin(4, varname);
        }
    }
    else if((ch == '&') || (ch == '@'))     /* long variable -or- array */
    {
        p_string[pi] = ' ';
        pi = iswhiter(pi);
        ch = p_string[pi];

        if(ch == '*')             /* an array */
        {
            e_pos = pend;
            Fix_VarArray2(varname, 10);
            p_string[pi] = ' ';
            pi = iswhiter(pi);
            pi = relocate(pi, pend);
        }
        else
        {
            p_string[pend] = ' ';
            e_pos = pend;
            s_pos = pstart;
            Sav_Destin(5, varname);
        }
    }
}
/*---------- end Scan_Var ----------*/








