/* bxbasm : AInput.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012      */
/*        ** stripped down version for Linux             */



/* ----- function prototypes ----- */
#include "prototyp.h"



void Header()
{
    open_destin();

    writeln(";\t*************BxbAsm Compiler*************");
    writeln(";\tCopyright: sarbayo (c) 2004-2012");
    writeln("; =========================================================================");
    writeln("  .486                       ; use 486 instructions");
    writeln("  .model flat, stdcall       ; Win32 memory model");
    writeln("  option casemap:none        ; case sensitive");
    writeln("; =========================================================================");
    writeln("; BXB Function Prototypes:");
    writeln("; =========================================================================");

    ScanDeclare();

    writeln(" ");
    writeln("; =========================================================================");
    writeln("  include BXB.inc");
    writeln("; -------------------------------------------------------------------------");
    writeln("; =========================================================================");
    writeln(";  INITIALIZED DATA");
    writeln("; =========================================================================");
    writeln(" .data");

    Prolog();
    Build_arrays();
}
/*---------- end Header ----------*/



void Prolog()                /* Write the Prolog */
{
    ScanVars();              /* pre-scan for quoted strings */

    writeln("; =========================================================================");
    writeln(";  UNINITIALIZED DATA");
    writeln("; =========================================================================");
    writeln(" .data?");
//    writeln("\tsystem_time \tSYSTEMTIME  <>\t\t\t;current date & time");
//    writeln("\tsa  \t\tSECURITY_ATTRIBUTES  <>");
//    writeln("\tcsbi  \t\tCONSOLE_SCREEN_BUFFER_INFO  <>");
//    writeln("\tiCOL\t\tdd\t?");
//    writeln("\tiROW\t\tdd\t?");
//    writeln("\tiYear\t\tdd\t?");
//    writeln("\tiMonth\t\tdd\t?");
//    writeln("\tiDay\t\tdd\t?");
//    writeln("\tiHour\t\tdd\t?");
//    writeln("\tiMinute\t\tdd\t?");
//    writeln("\tiSecond\t\tdd\t?");
//    writeln("\tiMilli\t\tdd\t?");
    writeln("\thStdHandle\tdd\t?");
    writeln("\tIntString\tdb\t12\t\tdup(?)\t; integer string");
    writeln("\tFltString\tdb\t28\t\tdup(?)");
    writeln("\tBffrInput\tdb\tBUFSIZE\t\tdup(?)");
    writeln("\tiohandles\tDD\t99\t\tdup(?)");
    writeln("\tiobuffers\tDD\t99\t\tdup(?)");
    writeln("\tiLVAR\t\tdd\t?");
    writeln("\tiRVAR\t\tdd\t?");
    writeln("\tqLVAR\t\tdq\t?");
    writeln("\tqRVAR\t\tdq\t?");
    writeln("\tarray_mtrx\tDW\t60\t\tdup(?)");

    load_tmpdata();

    writeln("; =========================================================================");
    writeln(" .code");
    writeln("; =========================================================================");
    writeln(" start:");
    writeln("; =========================================================================");
    writeln("  invoke Main");
    writeln("  invoke exit, 0");
    writeln("; =========================================================================");
    writeln("; --------------------------------------------------");
    writeln("Main proc");
    writeln("; --------------------------------------------------");
    writeln("  pushad");
//    writeln("  call Do_initialize");
}
/*---------- end Prolog ----------*/



void ScanVars()              /* identify and write all variables */
{   int ii;


    line_ndx = 0;

    while(line_ndx < nrows)
    {
        get_token();
        e_pos = 0;
        s_pos = 0;

        switch(token)
        {   case 1:               /* --- LET: statement --- */
                ScanLet();
                break;
            case 2:               /* --- CLEAR: statement --- */
                ScanPrint();
                break;
//            case 3:               /* --- LOCATE: statement --- */
//                ScanParam();
//                break;
            case 4:               /* --- PRINT: statement --- */
                ScanPrint();
                break;
            case 5:               /* --- GOTO: statement --- */
            case 9:               /* --- GOSUB: statement --- */
                ScanJump();
                break;
            case 11:              /* --- FOR: statement --- */
                ScanFor();
                break;
            case 13:              /* --- IF: statement --- */
            case 14:              /* --- ELSEIF: statement --- */
                ScanIf();
                break;
            case 17:              /* --- INPUT: statement --- */
            case 18:              /* --- LINE INPUT: statement --- */
                ScanPrint();
                break;
            case 19:              /* --- OPEN: statement --- */
                ScanOpen();
                break;
            case 21:              /* --- WRITE: statement --- */
                ScanWrite();
                break;
            case 22:              /* --- FIELD: statement --- */
                ScanField();
                break;
            case 23:              /* --- LSET: statement --- */
            case 24:              /* --- RSET: statement --- */
                ScanLet();
                break;
            case 25:              /* --- PUT: statement --- */
            case 26:              /* --- GET: statement --- */
                ScanPut();
                break;
            case 27:              /* --- CHDIR: statement --- */
            case 28:              /* --- MKDIR: statement --- */
            case 29:              /* --- RMDIR: statement --- */
            case 30:              /* --- KILL: statement --- */
                ScanPrint();
                break;
            case 31:              /* --- NAME/RENAME: statement --- */
                ScanRename();
                break;
            case 32:              /* --- FILES: statement --- */
                ScanFiles();
                break;
            case 33:              /* --- SHELL: statement --- */
                ScanShell();
                break;
            case 34:              /* --- RANDOM: statement --- */
                ScanParam();
                break;
            case 35:              /* --- READ: statement --- */
                ScanFInput();
                break;
            case 37:              /* --- WHILE: statement --- */
                ScanIf();
                break;
            case 43:              /* --- LPRINT: statement --- */
                ScanLPrint();
                break;
//            case 44:              /* --- COLOR: statement --- */
//                ScanParam();
//                break;
            case 46:              /* --- DIM: statement --- */
                ScanDim();
                break;
            case 47:              /* --- ERASE-FREE: statement --- */
                ScanErase();
                break;
//            case 55:              /* --- MESSAGEBOX: statement --- */
//                ScanMsgBox();
//                break;
            case 57:              /* --- SUB: statement --- */
                ScanSub();
                // set SUB flag here
                scansubflag = 1;
                break;
            case 58:              /* --- ENDSUB: statement --- */
                // reset SUB flag here
                scansubflag = 0;
                break;


        }

        line_ndx++;
    }

    SystemConst();                /* write system constants */

    for(ii=0; ii < VarNdxCnt; ii++)    /* clear var name index */
    {
        free(VarIndx[ii]);
    }

    free(VarIndx);
}
/*---------- end ScanVars ----------*/



void SystemConst()
{
    writeln("; --------------------------------------------------");
    writeln("; Do Not Delete !!!:  Constants and system variables");
    writeln("; --------------------------------------------------");
    writeln("\tinteger    dd  0");
    writeln("\tx87buff    dq  0");
    writeln("; --------------------------------------------------");
}
/*---------- end SystemConst ----------*/



void Epilog()                /* Write the Epilog */
{
    writeln(";");

    PostLabel("DONE");

    writeln("  ; --------------------------------------------------");
    writeln("  ; --------------------------------------------------");
    writeln("Alldone:");

    writeln("  call _getch \t\t\t  ; pause");
    writeln("  popad");
    writeln("  ret                                       ; return to windows");
    writeln("  ; --------------------------------------------------");
    writeln("Main endp");
    writeln("; =========================================================================");

    Do_sub_functions();      /* --- write sub functions --- */
    Do_functions();          /* --- write functions --- */

    writeln("  include Bxbasm.inc");
    writeln("; =========================================================================");
    writeln("end start");
    writeln("; =========================================================================");
    writeln("; =========================================================================");

    fclose(f_out);

    printf("Lines compiled: %d\n", nrows);
    printf("Done.\n\n\n");
}
/*---------- end Epilog ----------*/



void open_destin()
{   char ch, dot='.', destin[PATH];
    int ii;


    strcpy(destin, s_holder);          /* copy source file name */
    ii = 0;
    ch = '\0';

    while(ch != dot)
    {
        ch = s_holder[ii];             /* make source.bas = source. */
        ii++;
    }

    destin[ii] = '\0';
    strcat(destin, "asm");             /* append "asm" to filename */
    strcpy(t_holder, destin);          /* copy asm source filename */

    f_out = fopen(destin,"w");         /* open destination file (write) */
    printf("Destination file: %s\n",destin);

    s_datatemp = fopen("sdatatmp.tmp","w");     /* open temp file */
    i_datatemp = fopen("idatatmp.tmp","w");     /* open temp file */
    f_datatemp = fopen("fdatatmp.tmp","w");     /* open temp file */
    x_datatemp = fopen("xdatatmp.tmp","w");     /* open temp file */

    s_writeln("\t_var_start\tdd\t?");           /* string data */
    i_writeln("\t_int_start\tdd\t?");           /* integer data */
    f_writeln("\t_flt_start\tdd\t?");           /* float data */
    x_writeln("\t_arry_start\tdd\t?");          /* arrays data */
}
/*---------- end open_destin ----------*/



void load_tmpdata()
{   char tmp_string[BUFSIZE];
    int x;
    FILE *datatemp;


    f_writeln("\t_var_endzz\tdd\t?");
    f_writeln("\tStringBffr\tdb\tMBUFSIZE\tdup(?)");

    fclose(s_datatemp);
    fclose(i_datatemp);
    fclose(f_datatemp);
    fclose(x_datatemp);

    datatemp = fopen("sdatatmp.tmp","r");   /* open temp file */

    while(!feof(datatemp))
    {
        fgets(tmp_string, BUFSIZE, datatemp);

        if(!feof(datatemp))
        {
            write_str(tmp_string);          /* write data to file */
        }
        tmp_string[0] = '\0';
    }

    fclose(datatemp);

    datatemp = fopen("idatatmp.tmp","r");   /* open temp file */

    while(!feof(datatemp))
    {
        fgets(tmp_string, BUFSIZE, datatemp);

        if(!feof(datatemp))
        {
            write_str(tmp_string);     /* write data to file */
        }
        tmp_string[0] = '\0';
    }

    fclose(datatemp);

    datatemp = fopen("fdatatmp.tmp","r");   /* open temp file */

    while(!feof(datatemp))
    {
        fgets(tmp_string, BUFSIZE, datatemp);

        if(!feof(datatemp))
        {
            write_str(tmp_string);     /* write data to file */
        }
        tmp_string[0] = '\0';
    }

    fclose(datatemp);

    datatemp = fopen("xdatatmp.tmp","r");   /* open temp file */

    while(!feof(datatemp))
    {
        fgets(tmp_string, BUFSIZE, datatemp);

        if(!feof(datatemp))
        {
            write_str(tmp_string);     /* write data to file */
        }
        tmp_string[0] = '\0';
    }

    fclose(datatemp);

    x = remove("sdatatmp.tmp");        /* if '0', successful */
    x = remove("idatatmp.tmp");        /* if '0', successful */
    x = remove("fdatatmp.tmp");        /* if '0', successful */
    x = remove("xdatatmp.tmp");        /* if '0', successful */
}
/*------- end load_tmpdata ----------*/




