/* Bxbasm.c : Masm, JWasm  alpha version 1.06.3     */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012 */
/*       ** stripped down version for Linux         */


/*--------------------- DECLARE HEADERS ---------------------*/
/*----------------------               ----------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>



/*--------------------- FILE INCLUDES ---------------------*/
/*----------------------             ----------------------*/

#include "globals.h"              /* global variables::do not move from here */
#include "prototyp.h"             /* function prototypes */

#include "Input.c"
#include "Utility.c"
#include "AInput.c"
#include "AUtils.c"
#include "AFunct.c"
#include "Error.c"
#include "AVars.c"
#include "ARdp.c"
#include "ANinput.c"
#include "ALoops.c"
#include "AIf.c"
#include "AString.c"
#include "AFile.c"
#include "ADInput.c"
#include "Scandim.c"
#include "Scanlet.c"
#include "Scanprint.c"
#include "Scanmisc.c"
#include "Scanfor.c"
#include "Scanfile.c"
#include "Output.c"
#include "ASubs.c"
#include "AConsole.c"



/* ----- begin program ------------- */

int main(int argc, char *argv[])
{   int x=0, ab_code=1;


    printf("Copyright: Blunt_Axe_Basic, BxbAsm,");
    printf(" Bxbasic (c) sarbayo, 2004-2012\n");
    printf("Alpha Release: 1.06.3, Bxbasm Compiler\n\n");
    printf("** stripped down version for Linux\n\n");


    if(argc != 2)
    {
        a_bort(ab_code, x);
    }

    init_fldbffrs();              /* initialize file buffers */
    line_cnt(argv);
    Header();
    pgm_parser();
    Epilog();

    clr_arrays();                 /* --- end of program --- */
    return 0;
}
/*---------- end main ----------*/



void pgm_parser()
{
    line_ndx = 0;

    while(line_ndx < nrows)
    {
        s_pos = 0;
        e_pos = 0;
        get_token();
        parser();
        line_ndx++;
    }
}
/*---------- end pgm_parser ----------*/



void get_token()
{
    strcpy(p_string, array1[line_ndx]);
    token = byte_array[line_ndx];
}
/*---------- end get_token ----------*/



void parser()
{   int ab_code=4, x=line_ndx;


    if(token != -1)
    {
        num_label();              /* write a numeric label */
    }

    switch(token)
    {   case 1:              /* LET */
            Do_let();
            break;
        case 2:              /* CLEAR  (variables) */
            clr_vars();
            break;
//        case 3:              /* LOCATE */
//            Do_locate();
//            break;
        case 4:              /* PRINT */
            Do_print();
            break;
        case 5:              /* GOTO */
            Do_goto();
            break;
//        case 6:              /* BEEP */
//            Do_beep();
//            break;
//        case 7:              /* CLS */
//            Do_cls();
//            break;
        case 8:              /* END */
            Do_end();
            break;
        case 9:              /* GOSUB */
            Do_gosub();
            break;
        case 10:             /* RETURN */
            Do_return();
            break;
        case 11:             /* FOR */
            Do_for();
            break;
        case 12:             /* NEXT */
            Do_next();
            break;
        case 13:             /* IF */
            Do_if();
            break;
        case 14:             /* ELSEIF */
            Do_elseif();
            break;
        case 15:             /* ELSE */
            Do_else();
            break;
        case 16:             /* ENDIF */
            Do_endif();
            break;
        case 17:             /* INPUT */
            get_input();
            break;
        case 18:             /* LINE INPUT */
            get_lninput();
            break;
        case 19:             /* OPEN */
            parse_open();
            break;
        case 20:             /* CLOSE */
            Do_fclose();
            break;
        case 21:             /* WRITE */
            write_io();
            break;
        case 22:             /* FIELD */
            Do_field();
            break;
        case 23:             /* LSET */
            Do_lset();
            break;
        case 24:             /* RSET */
            Do_rset();
            break;
        case 25:             /* PUT */
            Do_put();
            break;
        case 26:             /* GET */
            Do_get();
            break;
        case 27:             /* CHDIR */
            parse_chd();
            break;
        case 28:             /* MKDIR */
            parse_mkd();
            break;
        case 29:             /* RMDIR */
            parse_rmd();
            break;
        case 30:             /* KILL */
            parse_kill();
            break;
        case 31:             /* NAME-RENAME */
            parse_name();
            break;
        case 32:             /* FILES */
            parse_shell();
            break;
        case 33:             /* SHELL */
            parse_shell();
            break;
        case 34:             /* RANDOM */
            seed_rand();
            break;
        case 35:             /* READ */
            input_io();
            break;
        case 36:             /* CHDRIVE */
            parse_chdrive();
            break;
        case 37:             /* WHILE */
            Do_while();
            break;
        case 38:             /* WEND */
            Do_wend();
            break;
        case 39:             /* LOOP */
            Do_loop();
            break;
        case 40:             /* ENDLOOP */
            Do_endloop();
            break;
        case 41:             /* BREAK */
            Do_break();
            break;
        case 42:             /* DO-WHILE */
            Do_do();
            break;
        case 43:             /* LPRINT */
            Do_lprint();
            break;
//        case 44:             /* COLOR */
//            Do_color();
//            break;
        case 45:             /* ASM */
            Do_asm();
            break;
        case 46:             /* DIM */
            Do_dim();
            break;
        case 47:             /* ERASE-FREE */
            Do_erase();
            break;
        case 48:             /* REDIM */
            Do_redimArray();
            break;
        case 49:             /* SWITCH */
            Do_Switch();
            break;
        case 50:             /* CASE */
            Do_SwitchCase();
            break;
        case 51:             /* DEFAULT */
            Do_SwitchDefault();
            break;
        case 52:             /* ENDSWITCH */
            Do_EndSwitch();
            break;
//        case 53:             /* SLEEP */
//            Do_Sleep();
//            break;
        case 54:             /* PAUSE */
            do_pause();
            break;
//        case 55:             /* MESSAGEBOX command */
//            do_messagebox();
//            break;
        case 56:             /* DECLARE */
            return;
            break;
        case 57:             /* SUB */
            Do_Sub();
            // set SUB flag here
            scansubflag = 1;
            break;
        case 58:             /* ENDSUB */
            Do_EndSub();
            // reset SUB flag here
            scansubflag = 0;
            break;
        case 59:             /* CALL */
            do_callsub();
            break;



        case 99:             /* dump */
            dump();
            break;
        case -1:             /* block label */
            Do_label();
            break;
        default:
            a_bort(ab_code, x);
            break;
    }
}
/*---------- end parser ----------*/



void num_label()                  /* post a numeric line label */
{   char ch, label[LLEN];


    ch = label_nam[line_ndx][0];

    if(isdigit(ch))
    {
        strcpy(label, "L");
        strcat(label, label_nam[line_ndx]);
        PostLabel(label);         /* Post Label To Output */
    }
}
/* ------- end num_label ------- */





