/* bxbasm : Scandim.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012       */
/*         ** stripped down version for Linux             */



/* ----- function prototypes ----- */
#include "prototyp.h"



void ScanDim()
{   int test, pi, len;       /* is this a "Dim var" or "Dim array" ? */


    pi = 0;
    e_pos = pi;
    len = strlen(p_string);

    test = isthis_anarray(pi, len);

    if(scansubflag == 1)     /* Dim a Local variable */
    {
        dim_local_var();
    }
    else if(test == 0)       /* not an array */
    {
        dim_var();           /* Dim global or local var */
    }
    else
    {                        /* Dim an array */
        dim_array();
    }
}
/*---------- end ScanDim -----------*/



void dim_var()
{   char ch;
    int pi, len;


    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];
                                       /* DIM x=1, y=2, z=3 */
    while((ch != '\n') && (pi < len))
    {
        if(isalpha(ch))
        {
            parse_dim();
            pi = e_pos;
        }
        else
        {
            pi = get_alpha(pi, len);
            ch = p_string[pi];
            e_pos = pi;
        }

        ch = p_string[pi];
        len = strlen(p_string);   /* expect len to change with every pass */
    }
}
/*---------- end dim_var -----------*/



void parse_dim()
{   char varname[VAR_NAME];
    int pi, len, type;
    int ab_code=28, x=line_ndx;   /* I think this err msg is ok */


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);

    if(pi == len)                      /* error: didn't find it */
    {
        a_bort(ab_code, x);
    }

    e_pos = pi;
    strcpy(varname, get_varname());    /* get variable name */
    pi = e_pos;

    type = get_Nvtype(pi);
    e_pos = pi;

    switch(type)
    {   case 0:                        /* string */
            ScanDimString(varname);
            break;
        case 1:                        /* no type sign */
        case 2:                        /* long integer */
        case 3:                        /* single float */
        case 4:                        /* double float */
            ScanDimNumeric(varname, type);
            break;
    }
}
/*-------- end parse_dim ---------*/



void ScanDimString(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, len, type;


    strcpy(varname, Name);
    Fix_String(varname);

    len = strlen(p_string);
    pi = e_pos;
    pi = get_rightExp(pi);        /* jump pi over this operator */
    ch = p_string[pi];

    e_pos = pi;

    if(ch == '\"')                /* found a quoted string */
    {
        GetNewVar();              /* get new varname */
    }
    else if(isalpha(ch))
    {
        strcpy(varname, get_varname());     /* get varname */
        type = get_ObjectType(varname);

        if(type == 6)
        {
    //        Fix_StrArray(varname);
    //        pi = e_pos;
    //        pi = get_paren(pi, len);
    //        ScanArrayParam();
        }
        else
        {
            Fix_String_A(varname);
        }
    }
    else if(isdigit(ch))          /* a string function number */
    {
        len = scanStr_funct(len);
    }

    pi = e_pos;
    pi = get_rightExp(pi);
    e_pos = pi;

}
/*---------- end ScanDimString ----------*/



void ScanDimNumeric(char *name, int type)
{   char ch, varname[VAR_NAME];
    int pi, len, ival, funcflag=0;


    strcpy(varname, name);
    pi = e_pos;
    len = strlen(varname);
    s_pos = pi - len;

    Sav_Destin(type, varname);         /* save destination name */

    pi = e_pos;                        /* handle expresions */
    len = strlen(p_string);

    while(pi < len)
    {
        ch = p_string[pi];

        while((isalnum(ch) == 0) && (pi < len) && (strchr(".\"",ch) == 0))
        {
            pi++;
            ch = p_string[pi];

            if(ch == '?')              /* math function: ?1(num) */
            {
                e_pos = pi + 1;
                ival = (int) get_avalue();

                if((ival == 10) || (ival == 11) || (ival == 29))
                {
                    pi = len;          /* LOC, LOF, EOF */
                }
                else
                {                                /* any other function */
                    pi = get_paren(pi, len);     /* ?num(string$) */
                    ch = p_string[pi];           /* ----^	     */
                    funcflag = 1;
                }
            }
        }

        if(pi < len)
        {
            e_pos = pi;

            if(funcflag == 1)          /* this is a math function */
            {
                ScanMathFunc(len);
                funcflag = 0;
            }
            else if((isdigit(ch)) || (ch == '.'))
            {
                GetNewTmp();           /* get new temp varname */
            }
            else if(isalpha(ch))       /* an array or variable name */
            {
                pi = e_pos;
                strcpy(varname, get_varname());  /* get varname */
                type = get_ObjectType(varname);

                if((type >= 7) && (type <= 10))  /* an array name */
                {
//                    Fix_VarArray(varname);
//                    pi = e_pos;
//                    pi = get_paren(pi, len);
//                    ScanArrayParam();
                }
                else
                {
                    e_pos = pi;
                    AddNewVar();       /* a variable name */
                }
            }
            pi = e_pos;
            len = strlen(p_string);
        }
    }
}
/*---------- end ScanDimNumeric ----------*/



void Fix_String(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, len;


    strcpy(varname, Name);
    len = strlen(varname);
    pi = e_pos;
    s_pos = pi - len;
    ch = p_string[pi];

    if(ch == '$')
    {
        p_string[pi] = ' ';
        Sav_String(varname);
        StorVar(varname);
    }
}
/*---------- end Fix_String ----------*/



int scanStr_funct(int len)
{   char ch, varname[VAR_NAME];
    int pi, type;


    pi = e_pos;
    pi = get_paren(pi,len);

    if(pi >= len)
    {
        e_pos = pi;               /* a$ = INKEY$, TIME$, DATE$ */
        return len;
    }

    pi++;
    pi = iswhite(pi);
    ch = p_string[pi];

    while((ch != ')') && (ch != '\n') && (pi < len))
    {
        ch = p_string[pi];
        e_pos = pi;

        if(ch == '\"')            /* found a quoted string */
        {
            GetNewVar();          /* get new varname */
        }
        else if((isdigit(ch)) || (strchr("-.", ch)))
        {
            GetNewTmp();          /* get new temp varname */
        }
        else if(isalpha(ch))                /* a variable name */
        {
            strcpy(varname, get_varname()); /* get varname */
            pi = e_pos;
            type = get_vtype(pi);           /* get variable type */

            if(type == 0)                   /* string variables */
            {
                Fix_String_A(varname);
            }
            else                            /* numeric variables */
            {
                len = strlen(varname);
                s_pos = pi - len;
                type = get_Nvtype(pi);
                Sav_Destin_A(type, varname);     /* save variable name */
            }
        }

        pi = e_pos;
        len = strlen(p_string);
        ch = p_string[pi];

        if(strchr("$, %!#@&", ch))
        {
            pi++;
        }
    }

    e_pos = pi;

    return len;
}
/*---------- end scanStr_funct ----------*/



void Sav_Destin(int type, char *Name)
{   char ch, varname[VAR_NAME];
    int pi, ab_code=5, x=line_ndx;


    strcpy(varname, Name);
    pi = e_pos;
    ch = p_string[pi];

    if(strchr("%!#@&", ch))
    {
        p_string[pi] = ' ';
    }

    if((type == 1) || (type == 2))     /* 16 or 32 Bit Integer */
    {
        if(check_VarName(varname) == 0)     /* verify no duplicates */
        {
            i_write_str("\t");
            i_write_str(varname);
            i_writeln("\t\tDD\t?");

            Sav_ObjName(varname, type, 0);
        }
        else
        {                         /* found duplicate var-name */
            ab_code=29;
            a_bort(ab_code, x);
        }
    }
    else if((type >= 3) && (type <= 5))     /* 32 or 64 Bit Float -or- */
    {                                       /* 64 Bit Long-Long Integer */
        if(check_VarName(varname) == 0)     /* verify no duplicates */
        {
            f_write_str("\t");
            f_write_str(varname);
            f_writeln("\t\tDQ\t?");

            Sav_ObjName(varname, type, 0);
        }
        else
        {                         /* found duplicate var-name */
            ab_code=29;
            a_bort(ab_code, x);
        }
    }
    else
    {
        a_bort(ab_code, x);
    }

    StorNVar(varname);            /* save destination name */
}
/*---------- end Sav_Destin ----------*/



void dim_array()
{   char ch, varname[VAR_NAME];
    int pi, len, type;
    int ab_code=25, x=line_ndx;


  /* printf("dim_array:: %s", p_string); /**/

    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];

    while((pi < len) && (ch != '\n'))
    {
        strcpy(varname, get_varname());
        pi = e_pos;
        type = get_Dvtype(pi);

     /* printf("name=%s, type=%d\n", varname, type); /**/

        e_pos = pi;

        if(type == 6)             /* character string array */
        {
            Fix_StrArray3(varname, len);
        }
        else if((type >= 7) && (type <= 10))     /* numeric array */
        {
            Fix_VarArray3(varname, type, len);
        }
        else
        {                         /* not a recognized object */
            a_bort(ab_code, x);
        }

        len = strlen(p_string);
        pi = e_pos;
        ch = p_string[pi];
        pi = get_rightExp(pi);
        ch = p_string[pi];
        e_pos = pi;
    }

  /* printf("dim_array::%s", p_string); /**/

}
/*---------- end dim_array ----------*/



void Fix_StrArray3(char *Name, int len)
{   char varname[VAR_NAME];
    int pi, xcnt;
    int ab_code=26, x=line_ndx;


    strcpy(varname, Name);
    Fix_StrArray(varname);

    if(check_VarName(varname) != 0)
    {
        a_bort(ab_code, x);
    }

    if(check_arrayName(varname) == 0)       /* register array-name */
    {
        x_write_str("\t");
        x_write_str(varname);
        x_writeln("\t\tDD\t?");
        x_writeln("\t\t\tDW\t61\tdup(?)");

        pi = e_pos;
        pi = get_paren(pi, len);
        s_pos = pi;

        xcnt = get_paramsCount(pi, len);   	/* get params count */
        Sav_ObjName(varname, 6, xcnt);		/* save object name */

        pi++;
        pi = get_paren(pi, len);
        pi++;
        e_pos = pi;
    }
}
/*---------- end Fix_StrArray3 ----------*/



void Fix_VarArray3(char *Name, int type, int len)
{   char varname[VAR_NAME];
    int pi, xcnt;
    int ab_code=26, x=line_ndx;


    strcpy(varname, Name);
    Fix_VarArray(varname);

    if(check_VarName(varname) != 0)
    {
        a_bort(ab_code, x);
    }

    if(check_arrayName(varname) == 0)  /* register array-name */
    {
        x_write_str("\t");
        x_write_str(varname);
        x_writeln("\t\tDD\t?");
        x_writeln("\t\t\tDW\t61\tdup(?)");

        pi = e_pos;
        pi = get_paren(pi, len);
        s_pos = pi;

        xcnt = get_paramsCount(pi, len);    /* get params count */
        Sav_ObjName(varname, type, xcnt);   /* save object name */

        pi++;
        pi = get_paren(pi, len);
        pi++;
        e_pos = pi;
    }
}
/*---------- end Fix_VarArray3 ----------*/



void Fix_StrArray(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, len;


    strcpy(varname, Name);
    len = strlen(varname);
    pi = e_pos;
    s_pos = pi - len;
    ch = p_string[pi];

    if(ch == '$')
    {
        p_string[pi] = ' ';
        StorVar(varname);
    }
}
/*---------- end Fix_StrArray ----------*/



void Fix_VarArray(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, len;


    strcpy(varname, Name);
    len = strlen(varname);
    pi = e_pos;
    s_pos = pi - len;
    ch = p_string[pi];

    if(strchr("%!#@&", ch))
    {
        p_string[pi] = ' ';
        StorVar(varname);         /* save array name */
    }
}
/*---------- end Fix_VarArray ----------*/



/*==================== DIM LOCAL VARIABLES ====================*/



void dim_local_var()
{   char ch;
    int pi, len;


    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];
                                       /* DIM x=1, y=2, z=3 */
    while((ch != '\n') && (pi < len))
    {
        if(isalpha(ch))
        {
            parse_local_dim();
            pi = e_pos;
        }
        else
        {
            pi = get_alpha(pi, len);
            ch = p_string[pi];
            e_pos = pi;
        }

        ch = p_string[pi];
        len = strlen(p_string);   /* expect len to change with every pass */
    }
}
/*---------- end dim_var -----------*/



void parse_local_dim()
{   char varname[VAR_NAME];
    int pi, len, ndx=0, type;
    int ab_code=28, x=line_ndx;   /* I think this err msg is ok */


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);

    if(pi == len)                      /* error: didn't find it */
    {
        a_bort(ab_code, x);
    }

    e_pos = pi;
    strcpy(varname, get_varname());    /* get variable name */
    pi = e_pos;

    type = get_Nvtype(pi);

    e_pos = pi;

    switch(type)
    {
        case 0:                        /* string */
            Scan_LocalDim_String(varname);
            break;
        case 1:                        /* no type sign */
        case 2:                        /* long integer */
        case 3:                        /* single float */
        case 4:                        /* double float */
            Scan_LocalDim_Numeric(varname, type);
            break;
        default:
            break;
    }
}
/*------ end parse_Local_dim ------*/



void Scan_LocalDim_String(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, len, type;


    strcpy(varname, Name);
    Fix_Local_String(varname);

    len = strlen(p_string);
    pi = e_pos;
    pi = get_rightExp(pi);        /* jump pi over this operator */
    ch = p_string[pi];

    e_pos = pi;

    if(ch == '\"')                /* found a quoted string */
    {
        GetNewVar();              /* get new varname */
    }
    else if(isalpha(ch))
    {
        strcpy(varname, get_varname());     /* get varname */
        type = get_ObjectType(varname);

        if(type == 6)
        {
        }
        else
        {
            Fix_String_A(varname);
        }
    }
    else if(isdigit(ch))          /* a string function number */
    {
        len = scanStr_funct(len);
    }

    pi = e_pos;
    pi = get_rightExp(pi);

    e_pos = pi;

}
/*------ end Scan_LocalDim_String ------*/



void Fix_Local_String(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, len;


    strcpy(varname, Name);
    len = strlen(varname);
    pi = e_pos;
    s_pos = pi - len;
    ch = p_string[pi];

    if(ch == '$')
    {
        p_string[pi] = ' ';
        Sav_LocalString(varname);
        StorVar(varname);
    }
}
/*------ end Fix_Local_String ------*/



void Sav_LocalString(char *Name)
{   char varname[VAR_NAME];
    int ab_code=29, x=line_ndx;


    strcpy(varname, Name);

    if(check_VarName(varname) == 0)
    {
        Sav_ObjName(varname, 0, 0);
    }
    else
    {                             /* found duplicate var-name */
        a_bort(ab_code, x);
    }
}
/*------ end Sav_LocalString ------*/



void Scan_LocalDim_Numeric(char *name, int type)
{   char ch, varname[VAR_NAME];
    int pi, len, ival, funcflag=0;


    strcpy(varname, name);
    pi = e_pos;
    len = strlen(varname);
    s_pos = pi - len;

    Sav_Local_Destin(type, varname);   /* save destination name */

    pi = e_pos;                        /* handle expresions */
    len = strlen(p_string);
    ch = p_string[pi];

    while((isalnum(ch) == 0) && (pi < len) && (strchr(".\"",ch) == 0))
    {
        pi++;
        ch = p_string[pi];

        if(ch == '?')             /* math function: ?1(num) */
        {
            e_pos = pi + 1;
            ival = (int) get_avalue();

            if((ival == 10) || (ival == 11) || (ival == 29))
            {
                pi = len;         /* LOC, LOF, EOF */
            }
            else
            {                               /* any other function */
                pi = get_paren(pi, len);    /* ?num(string$) */
                ch = p_string[pi];          /* ----^	     */
                funcflag = 1;
            }
        }
    }

    if(pi < len)
    {
        e_pos = pi;

        if(funcflag == 1)         /* this is a math function */
        {
            ScanMathFunc(len);
            funcflag = 0;
        }
        else if((isdigit(ch)) || (ch == '.'))
        {
            GetNewTmp();          /* get new temp varname */
        }
        else if(isalpha(ch))      /* an array or variable name */
        {
            pi = e_pos;
            strcpy(varname, get_varname());      /* get varname */
            type = get_ObjectType(varname);

            if((type >= 7) && (type <= 10))      /* an array name */
            {
            }
            else
            {
                e_pos = pi;
                AddNewVar();      /* a variable name */
            }
        }
    }
}
/*---------- end Scan_LocalDim_Numeric ----------*/



void Sav_Local_Destin(int type, char *Name)
{   char ch, varname[VAR_NAME];
    int pi, ab_code=5, x=line_ndx;


    strcpy(varname, Name);
    pi = e_pos;
    ch = p_string[pi];

    if(strchr("%!#@&", ch))
    {
        p_string[pi] = ' ';
    }

    if(check_VarName(varname) == 0)    /* verify no duplicates */
    {
        Sav_ObjName(varname, type, 0);
    }
    else
    {                             /* found duplicate var-name */
        a_bort(ab_code, x);
    }

    StorNVar(varname);            /* save destination name */
}
/*---------- end Sav_Local_Destin ----------*/














