/* bxbasm : Scanprint.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012         */
/*         ** stripped down version for Linux               */



/* ----- function prototypes ----- */
#include "prototyp.h"



void ScanPrint()
{   char ch, varname[VAR_NAME];
    int pi, type, len, ival;


 /* printf("ScanPrint::%s", p_string); /**/

    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
    ch = p_string[pi];

 /* printf("ch=%c, pi=%d, token=%d\n", ch, pi, token); /**/

    if(ch == '#')
    {
        if(token == 4)
        {
            ScanFPrint();         /* PRINT# statement */
        }
        else
        {
            ScanFInput();         /* INPUT# statement */
        }

        return;
    }

    while((pi < len) && (ch != '\n'))
    {
        e_pos = pi;

   /* printf("ch=%c pi=%d len=%d\n", ch, pi, len); /**/

        if(ch == '\"')            /* found a quoted string */
        {
            GetNewVar();          /* get new varname */
        }
        else if(ch == '?')        /* math function: ?1(num) */
        {
            e_pos = pi + 1;
            ival = (int) get_avalue();

            if((ival == 10) || (ival == 11) || (ival == 29))
            {
                pi = len;         /* LOC, LOF, EOF */
                e_pos = pi;
            }
            else                  /* any other function */
            {
                pi = get_paren(pi, len);    /* ?num(string$) */
                pi++;
                e_pos = pi;
                ScanMathFunc(len);
            }
        }
        else if(isalpha(ch))
        {
            strcpy(varname, get_varname());      /* get varname */
            s_pos = pi;
            pi = e_pos;
            type = get_ObjectType(varname);

            if(type == -1)             /* an undeclared variable */
            {
                type = get_vtype(pi);  /* ch == "$%@&!#" */
            }

      /* printf("name=%s type=%d pi=%d\n", varname, type, pi); /**/

            if(type == 0)              /* string variables */
            {
                Fix_String_A(varname);
            }
            else if(type == 6)         /* string array */
            {
                Fix_StrArray(varname);
                pi = get_paren(pi, len);
                ScanArrayParam();
            }
            else if((type >= 7) && (type <= 10)) /* numeric array */
            {
                Fix_VarArray(varname);
                pi = get_paren(pi, len);
                ScanArrayParam();
            }
            else                       /* numeric variables */
            {
                len = strlen(varname);
                s_pos = pi - len;

        //        type = get_Nvtype(pi);
       /* printf("type = %d, name=%s\n", type, varname); /**/

                Sav_Destin_A(type, varname);     /* save variable name */
            }
        }
        else if(isdigit(ch))           /* a string function number */
        {
            pi = get_NextOp(pi);
            ch = p_string[pi];

      /* printf("ch=%c pi=%d len=%d\n", ch, pi, len); */

            if(ch == '(')              /* is it a: 2(string) */
            {
                len = scanStr_funct(len);
            }
            else                       /* or: 2+2 */
            {
                GetNewTmp();           /* get new temp varname */
            }
        }

        pi = e_pos;
        ch = p_string[pi];
        len = strlen(p_string);

      /* printf("ch=%c pi=%d len=%d\n", ch, pi, len); /**/

        if(strchr(":; ,)(", ch) != 0)       /* jump over punctuation */
        {
            pi = get_rightExp(pi);          /* get to next alpha or string */
        }
        else if(strchr("$%!#@&", ch) != 0)  /* jump over var types */
        {
            pi = get_rightExp(pi);          /* get to next alpha or string */
        }
        else if(strchr("+-*/^", ch) != 0)   /* jump over operators */
        {
            pi = get_rightExp(pi);          /* get to next alpha or string */
        }

        e_pos = pi;
        ch = p_string[pi];

      /* printf("%s ch=%c pi=%d\n", p_string, ch, pi); /**/

    }

/* printf("Scanprint:: %s", p_string); /**/

}
/*---------- end ScanPrint ----------*/



void ScanFPrint()                 /* parse PRINT# statement */
{   char ch, NVar[12], varname[VAR_NAME], format[BUFSIZE];
    int pi, len, type, wflag=0, ii;
    unsigned size;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_digit(pi, len);
    pi = get_NextOp(pi);
    ch = p_string[pi];
    format[0] = '\0';

    while((pi < len) && (ch != '\n'))  /* process up to line terminator */
    {
        pi = get_rightExp(pi);
        ch = p_string[pi];
        e_pos = pi;

        if(ch == '\"')                 /* found a quoted string */
        {
            GetNewVar();               /* get new varname */
            strcat(format, "%s");
        }
        else
        {
            type = get_vtype(pi);

            if(type == 0)
            {
                e_pos = pi;
                strcpy(varname, get_varname());  /* get varname */
                Fix_String_A(varname);
                strcat(format, "%s");
            }
            else
            {
                e_pos = pi;                      /* output a value */
                AddNewVar_A();

                type = get_Nvtype(pi);

                if(type < 3)
                {
                    strcat(format, " %d");
                }
                else if(type < 5)
                {
                    strcat(format, " %f");
                }
                else
                {
                    strcat(format, " %lu");
                }
            }
        }

        pi = e_pos;
        ch = p_string[pi];
        len = strlen(p_string);

        if(strchr("$#!%@&", ch))
        {
            pi++;
            pi = iswhiter(pi);
            ch = p_string[pi];
        }
    }
 /* printf("format=%s\n", format); /**/

    strcpy(NVar, NewFVarname());       /* --- get new varname --- */
    strcat(NVar, "S");

    write_str("\t");
    write_str(NVar);
    write_str("\t\tDB\t\'");
    write_str(format);
    writeln("\',0");

    strcpy(format, "#");
    strcat(format, NVar);
    strcat(format, ", ");
    strcat(format, p_string);

    len = strlen(format);         /* --- save p_string to array --- */
    size = len + 1;
    ii = line_ndx;

    array1[ii] = realloc(array1[ii], size * sizeof(char));
    strcpy(array1[line_ndx], format);       /* store to array */

  /* printf("p_string:%s", format); /**/
}
/*------- end ScanFPrint ----------*/



void ScanLPrint()                 /* parse LPRINT statement */
{   char ch, NVar[12], varname[VAR_NAME], format[BUFSIZE];
    int pi, len, type, wflag=0, ii;
    unsigned size;


    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];
    format[0] = '\0';

    while((pi < len) && (ch != '\n'))  /* process up to line terminator */
    {
        pi = get_rightExp(pi);
        ch = p_string[pi];
        e_pos = pi;

        if(ch == '\"')                 /* found a quoted string */
        {
            GetNewVar();               /* get new varname */
            strcat(format, "%s");
        }
        else
        {
            type = get_vtype(pi);

            if(type == 0)
            {
                e_pos = pi;
                strcpy(varname, get_varname());  /* get varname */
                Fix_String_A(varname);
                strcat(format, "%s");
            }
            else                       /* output a value */
            {
                e_pos = pi;
                type = get_Nvtype(pi);
                AddNewVar();

                if(type < 3)
                {
                    strcat(format, " %d");
                }
                else if(type < 5)
                {
                    strcat(format, " %f");
                }
                else
                {
                    strcat(format, " %lu");
                }
            }
        }

        pi = e_pos;
        ch = p_string[pi];
        len = strlen(p_string);

        if(strchr("$#!%@&", ch))
        {
            pi++;
            pi = iswhiter(pi);
            ch = p_string[pi];
        }
    }
/* printf("format=%s\n", format); /**/

    strcpy(NVar, NewFVarname());       /* --- get new varname --- */
    strcat(NVar, "S");

    write_str("\t");
    write_str(NVar);
    write_str("\t\tDB\t\'");
    write_str(format);
    writeln("\',10,0");

    strcpy(format, "#");
    strcat(format, NVar);
    strcat(format, ", ");
    strcat(format, p_string);

    len = strlen(format);         /* --- save p_string to array --- */
    size = len + 1;
    ii = line_ndx;

    array1[ii] = realloc(array1[ii], size * sizeof(char));
    strcpy(array1[line_ndx], format);       /* store to array */

  /* printf("p_string:%s", format); */
}
/*------- end ScanLPrint ----------*/























