/* bxbasm : globals.h : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012       */
/*         ** stripped down version for Linux             */



/* --- declare constants --- */
#define BUFSIZE     256
#define TOKEN_LEN   21
#define VAR_NAME    33
#define LLEN        33
#define IOARRAY     99
#define PATH        129
#define REC_LEN     128


/* ------ global vars ------------ */
    FILE *f_in, *f_out;      /* these are the i/o file handles    */
    FILE *s_datatemp;        /* these are temp i/o file handles   */
    FILE *i_datatemp;        /* these are temp i/o file handles   */
    FILE *f_datatemp;        /* these are temp i/o file handles   */
    FILE *x_datatemp;        /* these are temp i/o file handles   */
    FILE *sub_iotemp;        /* SUB temp i/o file handle          */
    char *prog_name;         /* program source-file name          */
    char p_string[BUFSIZE];  /* file input string                 */
    char **array1;           /* program array                     */
    char t_holder[20];       /* token data holder                 */
    char s_holder[BUFSIZE];  /* xstring (print) data holder       */
     int nrows;              /* numbers of lines in source file   */
     int ncolumns=BUFSIZE;   /* dimension for array1[][columns]   */
     int line_ndx;           /* current execution line            */
     int s_pos, e_pos;       /* pointers to start & end of token  */
    char xstring[BUFSIZE];   /* the print string                  */
    char **temp_prog;        /* temp program array                */
    char **temp_label;       /* temp label name array             */
     int *temp_byte;         /* temp byte code array              */
     int *byte_array;        /* byte code array                   */
    char **label_nam;        /* labels name array                 */
     int token;              /* token: current byte code          */
     int var_type;           /* current variable type             */
     int var_count=0;        /* variables counter                 */
    char **VarIndx;          /* unique variables name index       */
     int VarNdxCnt=0;        /* unique variables count            */
     int UnqLblNdx=0;        /* unique labels count               */
    char **ForArray;         /* FOR: nested FOR labels            */
     int forLabelCtr=0;      /* FOR: nested label counter         */
    char indent[BUFSIZE] = {0,0}; /* IF: indentation string       */
     int indcnt=0;           /* IF: indentations for nested code  */
     int opcntr=0;           /* IF: number of nested ANDs/ORs     */
    char **label_endif;      /* IF: array, nested labels          */
     int endifCtr=-1;        /* IF: nested ENDIF counter          */
    char **label_block;      /* IF: array, nested blocks          */
    char label_Or[LLEN];     /* IF: label, OR                     */
     int Or_pi=0;            /* IF:                               */
    char **label_elseif;     /* ELSEIF: array, nested ELSEIF's    */
    char **label_else;       /* ELSE: array, nested ELSE's        */
    char **WhileArray;       /* WHILE: nested While labels        */
     int whileLblCtr=0;      /* WHILE: nested label counter       */
    char wlabel_block[LLEN]; /* WHILE: block label                */
    char **LoopArray;        /* LOOP: nested LOOP labels          */
     int loopLblCtr=0;       /* LOOP: nested label counter        */
    char **BreakArray;       /* BREAK: nested LOOP labels         */
     int breakCtr=0;         /* BREAK: nested BREAK counter       */
     int dowhileflag=0;      /* FLAG: DO-WHILE                    */
    char **ObjIndx;          /* object/variables name index       */
     int **ObjType;          /* object/variables type specifier   */
     int ObjNdxCnt=0;        /* object/variables index count      */

    char swlabel_block[LLEN];/* SWITCH: block label               */
     int switchLblCtr=0;     /* SWITCH: label counter             */

    char thisSubNam[VAR_NAME]; /* SUB: current sub name           */



/*------ dynamic arrays ------*/
    char **ArryNdx;          /* Array: name array                 */
     int *ArryParams;        /* Array: parameters count array     */
     int ArryNdxCnt=0;       /* Array: counter                    */
/*------ all arrays are dynamic ------*/


/*------ File I/O structures ---------*/
  struct field_buffer        /* File: Field Buffer structure      */
     {   char *f_bffr;            /* I/O buffer */
     unsigned bfr_size;           /* buffer length */
          int *str_len;           /* string length */
         char **str_name;         /* string name */
          int fld_count;          /* number of strings */
         long record;             /* current record number */
          int flag;               /* PUT flag, to clear buffer */
     };                      /* File: handles structure           */

  struct field_buffer fld_bffr[IOARRAY];
     int lset_ndx;           /* File: global Lset/Rset var_index  */

  struct lset_rset
     {    int ndx;
          int cnt;
     } lrs;
/*------ end File I/O structures ---------*/


/*--- FLAGS ---*/
     int stringcopy=0;       /* Flag: string copy: function       */
     int asnchrstr=0;        /* Flag: CHR$ function               */
     int asnleftstr=0;       /* Flag: LEFT$ function              */
     int asnrightstr=0;      /* Flag: RIGHT$ function             */
     int asnmidstr=0;        /* Flag: MID$ function               */
     int asnspacestr=0;      /* Flag: SPACE$ function             */
     int asnstrsIval=0;      /* Flag: STR$(integer) function      */
     int asnstrsFval=0;      /* Flag: STR$(double) function       */
     int asnstringstr=0;     /* Flag: STRING$ function            */
     int asninkeystr=0;      /* Flag: INKEY$  function            */
     int asninputstr=0;      /* Flag: INPUT$  function            */
     int asnmkdstr=0;        /* Flag: MKD$    function            */
     int asnmkistr=0;        /* Flag: MKI$    function            */
     int asnmkqstr=0;        /* Flag: MKI$ (quad) function        */
//     int resetcursor=0;      /* Flag: INPUT   function            */
//     int getsysdate=0;       /* Flag: DATE    function            */
//     int getsystime=0;       /* Flag: TIME    function            */
//     int asndatestr=0;       /* Flag: DATE$   function            */
//     int asntimestr=0;       /* Flag: DATE$   function            */
     int filecloseall=0;     /* Flag: close all files function    */
     int closeafile=0;       /* Flag: close a file function       */
     int getfilehandle=0;    /* Flag: get file handle function    */
     int clearstrngbffr=0;   /* Flag: clear I/O string function   */
     int setupiobuffer=0;    /* Flag: file I/O buffer function    */
     int asnlsetstr=0;       /* Flag: file LSET string function   */
     int asnrsetstr=0;       /* Flag: file RSET string function   */
     int clearallvars=0;     /* Flag: CLEAR variables function    */
     int clearstrvar=0;      /* Flag: CLEAR string    function    */
     int clearintvar=0;      /* Flag: CLEAR integer   function    */
     int clearfltvar=0;      /* Flag: CLEAR float     function    */
     int clearLngstrngbffr=0; /* Flag: clear i/o string function  */
     int movstrngbffr=0;     /* Flag: move input string function  */
     int readintstr=0;       /* Flag: move input integer function */
     int readfltstr=0;       /* Flag: move input float function   */
     int readQintstr=0;      /* Flag: move input integer function */
     int getfilelength=0;    /* Flag: LOF function                */
/*     int setcolortext=0;     /* Flag: COLOR function              */
     int dimstrarray=0;      /* Flag: DIM type:string function    */
     int getArryOffst=0;     /* Flag: array offset function       */
     int dblArryElement=0;   /* Flag: array integer element       */
     int quadArryElement=0;  /* Flag: array float element         */
     int freeArray=0;        /* Flag: array erase function        */
     int redimarray=0;       /* Flag: REDIM array function        */
     int sw_sub_handle=0;    /* Flag: open SUB handle             */
     int scansubflag=0;      /* Flag: scan SUB flag               */
/*     int hrtimer=0;          /* Flag: HiRezTimer function         */

/*--- FLAGS ---*/


